#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
// TreemapMod01.fsh  by   illus0r
//https://www.shadertoy.com/view/3ttfzf
//Licence : Creative Commons Attribution-ShareAlike 4.0
//http://creativecommons.org/licences/by-sa/4.0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define iMouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.000333)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

#define rnd(x) (sin(9e4*x)*.5+.5)


//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{ 
    vec2 uv = fragCoord/iResolution.xy;
    float split, edgeX1=0., edgeX2=1., edgeY1=0., edgeY2=1., spanX, spanY;
    split = rnd(iMouse.x/10000.);
    for(float i = 0.; i < 10.; i++) {
        spanX = edgeX2 - edgeX1;
        if (spanX < 0.04) break;
        if((uv.x-edgeX1)/spanX < split) {
            edgeX2 = edgeX1 + split*spanX;
            split = rnd(split+10.);
        }
        else {
            edgeX1 = edgeX1 + split*spanX;
            split = rnd(split+20.);
        }
        
        spanY = edgeY2 - edgeY1;
        if (spanY < 0.02) break;
        if((uv.y-edgeY1)/spanY < split) {
            edgeY2 = edgeY1 + split*spanY;
            split = rnd(split+10.);
        }
        else {
            edgeY1 = edgeY1 + split*spanY;
            split = rnd(split+20.);
        }   
    }
    spanY = edgeY2 - edgeY1;
    spanX = edgeX2 - edgeX1;
    uv.x = (uv.x-edgeX1)/spanX;
    uv.y = (uv.y-edgeY1)/spanY;
    fragColor = vec4(1.5-length(uv*2.-1.))*vec4(
        rnd(split),
        rnd(split+1.),
        rnd(split+2.),
        1.
    );
    fragColor *= step(.5,rnd(floor(length(uv-.5)*50.*split)));
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 vTexCoord = gl_TexCoord[0];
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

